﻿/* Function create_rechnung() */
/* # TODO write function create_rechnung() here */
CREATE OR REPLACE FUNCTION create_rechnung() RETURNS INTEGER AS $$
BEGIN
   INSERT INTO Rechnung(rdatum) VALUES (current_date);
   RETURN currval('seq_rechnung');
END;
$$ LANGUAGE plpgsql;


/* Function create_rpos(rnr INTEGER, anr INTEGER, apos INTEGER) */
/* # TODO write function create_rpos() here */
CREATE OR REPLACE FUNCTION create_rpos(v_rnr INTEGER, v_anr INTEGER, v_apnr INTEGER) RETURNS void AS $$
DECLARE
   v_rpnr INTEGER;
   v_wert NUMERIC(7,2);
   v_text VARCHAR(100);
BEGIN
   IF NOT EXISTS (SELECT anr, apnr FROM Leistungsposition l WHERE l.anr = v_anr AND l.apnr = v_apnr UNION
              SELECT anr, apnr FROM SonstigePosition s WHERE s.anr = v_anr AND s.apnr = v_apnr) THEN
       RAISE EXCEPTION 'Auftragsposition ist weder Leistungsposition nocht Sonstige Position!';
   END IF;

   SELECT COALESCE(MAX(rpnr),0)+1 INTO v_rpnr FROM RPosition WHERE rnr = v_rnr; 

   SELECT t.text into v_text FROM (SELECT beschreibung AS text 
                                 FROM SonstigePosition s
                                 WHERE s.anr = v_anr AND s.apnr = v_apnr 
                                    UNION
                                 SELECT l.bezeichnung AS text 
                                 FROM Leistungsposition p JOIN Leistung l ON p.leistung = l.lnr 
                                 WHERE p.anr = v_anr AND p.apnr = v_apnr) t;

   INSERT INTO RPosition VALUES (v_rnr, v_rpnr, v_anr, v_apnr, f_calc_apos(v_anr, v_apnr), v_text);
   
END;
$$ LANGUAGE plpgsql;

SELECT COALESCE(MAX(rpnr),0)+1 FROM RPosition WHERE rnr = 3; 
SELECT create_rpos(3, 30, 2);
DELETE FROM Rechnung WHERE rnr=13
SELECT * FROM RPosition;