﻿DROP FUNCTION archiv_kundendaten(); 

/* Function archiv_kundendaten() */
/* # TODO write function archiv_kundendaten() here */
CREATE OR REPLACE FUNCTION archiv_kundendaten() RETURNS TABLE(knr INTEGER, name VARCHAR(40), cnt INTEGER) AS $$
DECLARE
   c CURSOR FOR SELECT * FROM Kundendaten FOR UPDATE;
   count INTEGER;
BEGIN
   CREATE TABLE temp_cnt(
      knr INTEGER PRIMARY KEY REFERENCES Kunde(knr),
      cnt INTEGER DEFAULT 0);

   INSERT INTO temp_cnt(knr) SELECT k.knr FROM Kunde k;
   count := 0;

   FOR t IN c LOOP
      IF NOT EXISTS (SELECT * FROM AktKundendaten a WHERE a.knr = t.knr AND a.erstelldatum = t.erstelldatum) THEN 
         RAISE NOTICE 'INSERT INTO Kundendaten VALUES (%,''%'',''%'',%)',t.knr,t.erstelldatum,t.anschrift,t.sonderrabatt;
         UPDATE temp_cnt SET cnt = temp_cnt.cnt + 1 WHERE temp_cnt.knr = t.knr;
         DELETE FROM Kundendaten WHERE CURRENT OF c;
         count := count + 1;
      END IF;
   END LOOP;

   RAISE NOTICE '% Eintraege archiviert!', count;

   RETURN QUERY SELECT k.knr, k.name, t.cnt FROM kunde k JOIN temp_cnt t ON k.knr=t.knr ORDER BY knr;

   DROP TABLE temp_cnt;
END;
$$ LANGUAGE plpgsql;

SELECT * FROM archiv_kundendaten();
